// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================

package hep.lcio.event;


/** The LCIO TrackState class.
 * 
 * @author gaede, engels
 * @version $Id:$
 */

public interface TrackState extends LCObject {

     /** The location of the track state.
     *   Location can be set to: TrackState::AtIP, TrackState::AtFirstHit, TrackState::AtLastHit, TrackState::AtCalorimeter, TrackState::AtVertex, TrackState::AtOther
     */
    public int getLocation();

    /** Impact paramter of the track
     *  in (r-phi).
     */
    public float getD0();

    /** Phi of the track at the reference point.
     * @see getReferencePoint
     */
    public float getPhi();

    /** Omega is the signed curvature of the track in [1/mm].
     * The sign is that of the particle's charge.
     */
    public float getOmega();

    /** Impact paramter of the track
     *  in (r-z).
     */
    public float getZ0();

    /** Lambda is the dip angle of the track in r-z at the reference point. 
     * @see getReferencePoint
     */
    public float getTanLambda();

    /** Covariance matrix of the track parameters. Stored as lower triangle matrix where
     * the order of parameters is:   d0, phi, omega, z0, tan(lambda).
     * So we have cov(d0,d0), cov( phi, d0 ), cov( phi, phi), ...
     */
    public float[] getCovMatrix();

    /** Reference point of the track parameters.
     *  The default for the reference point is the point of closest approach.
     */
    public float[] getReferencePoint();

    public final static int AtOther = 0;

 // any location other than the ones defined below  
    public final static int AtIP = 1;

    public final static int AtFirstHit = 2;

    public final static int AtLastHit = 3;

    public final static int AtCalorimeter = 4;

    public final static int AtVertex = 5;

    public final static int LastLocation = AtVertex;
} // class or interface

