// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================

package hep.lcio.event;

import java.util.List;

/** A generic tracker hit to be used by pattern recognition.
 * 
 * @author gaede
 * @version $Id: TrackerHit.aid,v 1.16 2010-06-17 12:28:59 engels Exp $
 */

public interface TrackerHit extends LCObject {

   /** Same name as in CalorimeterHit, even though there are no 'cells' in this case
     */
    public int getCellID0();

    /** Same name as in CalorimeterHit, even though there are no 'cells' in this case
     *  Optional, check/set flag(LCIO::RTHBIT_ID1)==1.
     */
    public int getCellID1();

    /** The hit  position in [mm].	
     */
    public double[] getPosition();

    /** Covariance of the position (x,y,z), stored as lower triangle matrix. i.e.
     *  cov(x,x) , cov(y,x) , cov(y,y) , cov(z,x) , cov(z,y) , cov(z,z).
     */
    public float[] getCovMatrix();

    /** The dE/dx of the hit in [GeV].
     *  @deprecated
     *  @see getEDep()
     */
    public float getdEdx();

    /** The  time of the hit in [ns].
     */
    public float getTime();

    //     /**Type of raw data hit, either one of<br>
    //      * LCIO::TPCHIT<br>
    //      * LCIO::SIMTRACKERHIT<br>
    //      */
    //    public const String& getType() const ;
    /** Type of hit. Mapping of integer types to type names
     * through collection parameters "TrackerHitTypeNames"
     * and "TrackerHitTypeValues".
     */
    public int getType();

    /** The quality bit flag of the hit */
    public int getQuality();

    /** The energy deposited on the hit [GeV] */
    public float getEDep();

    /** The error measured on EDep [GeV] */
    public float getEDepError();

    /** The raw data hits. 
     * Check getType() to get actual data type.
     */
    public List getRawHits();

//     public void setPosition( double3V pos) ;
//     public void setCovMatrix( const FloatVec& cov) ;
//     public void setTime( float time ) ;
//     public void setTPCHit( TPCHit* hit ) ;
} // class or interface

